module Cubaru
  module V1
    module Address
      class Resource

        def initialize(resource)
          @resource = resource
        end

        def list(options={})
          Cubaru.submit(:get, address_url, options)["data"] || []
        end

        def find(address_id)
          Cubaru.submit :get, address_url(address_id)
        end

        def create(options = {})
          Cubaru.submit :post, address_url, @resource.format_address_params(options)
        end

        def destroy(address_id)
          Cubaru.submit :delete, address_url(address_id)
        end

        private

        def address_url(address_id = nil)
          @resource.construct_url("addresses", address_id)
        end
      end
    end
  end
end
