module Cubaru
  module V1
    module Postcard
      class Resource

        def initialize(resource)
          @resource = resource
        end

        def list(options={})
          Cubaru.submit(:get, postcard_url, options)["data"] || []
        end

        def find(postcard_id)
          Cubaru.submit :get, postcard_url(postcard_id)
        end

        def create(options = {})
          if options[:to] && !options[:to].is_a?(String)
            options[:to] = @resource.format_address_params(options[:to])
          end

          if options[:from] && !options[:from].is_a?(String)
            options[:from] = @resource.format_address_params(options[:from])
          end

          Cubaru.submit :post, postcard_url, options
        end

        private

        def postcard_url(postcard_id = nil)
          @resource.construct_url("postcards", postcard_id)
        end

      end
    end
  end
end
