module Cubaru
	module V1
		class Resource

			attr_accessor :options

			def initialize(options)
				@options = options
			end

			def addresses
				Cubaru::V1::Address::Resource.new(self)
			end

			def postcards
				Cubaru::V1::Postcard::Resource.new(self)
			end

			def base_url
				"#{@options[:protocol]}://#{@options[:api_key]}:@#{@options[:api_host]}/v1"
			end

			def construct_url(resource_type, resource_id=nil)
				"#{base_url}/#{resource_type}#{'/' + resource_id if resource_id}"
			end

      def format_address_params(params, check_required_options=true)
        if check_required_options
          Cubaru.require_options(params, :name, :address_line1, :city, :state, :zip, :country)
        end

        new_params = params.clone

        [:city, :state, :zip, :country].each do |option|
          new_params["address_#{option}".to_sym] = params[option] if params[option]
          new_params.delete(option)
        end

        new_params
      end
		end
  end
end
